<?php
/*
 * This file is part of the online-bookmarks project,
 * which you can find here:
 * http://www.frech.ch/online-bookmarks/
 *
 * This software is released under the General Public License
 * More detailes in the file 'GPL.html' or on the following
 * website: http://www.gnu.org and look for licenses
 *
 */
if (basename ($_SERVER['SCRIPT_NAME']) == basename (__FILE__)) {
	die ("no direct access allowed");
}

class bookmarks {

	var $bookmarks = array ();
	var $searchmode = false;

	function bookmarks ($args = false) {
		$user = $GLOBALS['user'];
		$this->folder = set_get_folder ();
		if (strtolower (basename($_SERVER['PHP_SELF'])) == "search.php" && is_array ($args)) {
			$this->searchmode = true;
			$searchstring = set_post_search ();
			$search_for = "";

			if (count ($args > 0)) {
				for ($i = 0; $i < count ($args); $i++) {
					if ($i == 0) {
						$operator = "";
					}
					else {
						$operator = "OR";
					}
					$search_for .= " $operator " . $args[$i] . " LIKE ('%".mysql_real_escape_string ($searchstring)."%')";
				}
			}
			require ("./folders.php");
			$this->tree = & new folder;

			$query = "SELECT
				bookmark.title,
				bookmark.url,
				bookmark.description,
				DATE_FORMAT(bookmark.date,'%d.%m.%Y') AS timestamp,
				bookmark.childof,
				bookmark.id,
				bookmark.favicon,
				folder.name,
				folder.id AS fid
		
				FROM bookmark
				LEFT JOIN folder ON bookmark.childof=folder.id
				WHERE bookmark.user=" . quote_smart ($user) . "
				AND bookmark.deleted!='1'
				AND ($search_for)
				ORDER BY title";
		}
		else {
			$query = "SELECT title, url, description, DATE_FORMAT(date,'%d.%m.%Y') AS timestamp, id, favicon
				FROM bookmark 
				WHERE user=".quote_smart ($user)."
				AND childof=".$this->folder."
				AND deleted!='1'
				ORDER BY title";
		}

		$bookmarks_result = mysql_query ($query) or die (mysql_error ());

		while ($row = mysql_fetch_assoc ($bookmarks_result)) {
			array_push ($this->bookmarks, $row);
		}
	}


	function display_bookmarks () {

		global $setting, $msg_edit, $msg_move, $msg_delete, $column_width_folder;
		require ("./config/config.php");

		echo '<form name="bookmarks">' . "\n";
		echo '<table width="97%">' . "\n";

		foreach ($this->bookmarks as $value) {
			echo "<tr>\n";

			# the folders, only needed when searching for bookmarks
			if ($this->searchmode) {
				if ($value['fid'] == null) {
					$value['name'] = $setting['root_folder_name'];
				}
				$expand = $this->tree->get_path_to_root ($value['fid']);
				$expand = implode (",", $expand);
				echo '<td style="width:' . $column_width_folder . ';">';
				echo '<a href="./index.php?expand=' . $expand . '&folder='. $value['fid'] .'#' . $value['fid'] . '">';
				echo $folder_opened . " " . $value['name'] . "</a>";
				echo "</td>\n";
			}

			# the checkbox, needed in any case
			echo '<td valign="top" width="10">';
			echo '<input type="checkbox" name="' . $value['id'] . '">';
			echo "</td>\n";

			# the bookmark image if configured to be displayed
			if ($setting['show_bookmark_icon']){
				echo '<td valign="top" width="10">';
				if ($value['favicon'] && is_file ($value['favicon'])) {
					echo '<img src="' . $value['favicon'] . '" width="16" height="16">';
				}
				else {
					echo $bookmark_image;
				}
				echo "</td>\n";
			}

			# the link, needed in any case, to be opened in new window or in originating window
			if ($setting['open_new_window']) {
				$target = ' target="_blank"';
			}
			else {
				$target = null;
			}
			echo '<td valign="top">';
			echo '<a href="' . $value['url'] . '" title="' . $value['url'] . '"' . $target . '>' . $value['title'] . '</a>';

			# the description if configured to be displayed and if not empty
			# thanks to Tim Hogan <tlhogan22@yahoo.com>
			if ($setting['show_bookmark_description'] && $value['description'] != "") {
				echo '<div class="description">' . $value['description'] . "</div>\n";
			}				

			echo "</td>\n";

			# the date column if configured to be displayed
			if ($setting['show_column_date']) {
				echo '<td valign="top" width="10">';
				echo $value['timestamp'];
				echo "</td>\n";
			}				

			# the edit column if configured to be displayed
			if ($setting['show_column_edit']) {
				echo '<td valign="top" width="10">';
				echo '<a href="javascript:bookmarkedit(\'' . $value['id'] . '\')">';
				echo sprintf ($edit_image, $msg_edit);
				echo "</a></td>\n";
			}

			# the move column if configured to be displayed
			if ($setting['show_column_move']) {
				$expand_m = implode (",", purge_expand_list ());
				echo '<td valign="top" width="10">';
				echo '<a href="javascript:bookmarkmove(\'' . $value['id'] . '\', \'' . 'expand=' . $expand_m . '&folder=' . $this->folder . '\')">';
				echo sprintf ($move_image, $msg_move);
				echo "</a></td>\n";
			}

			# the delete column if configured to be displayed
			if ($setting['show_column_delete']) {
				echo '<td valign="top" width="10">';
				echo '<a href="javascript:bookmarkdelete(\'' . $value['id'] . '\')">';
				echo sprintf ($delete_image, $msg_delete);
				echo "</a></td>\n";
			}

			echo "</tr>\n";
		}
		echo "</table></form>\n";
	}
}
?>
