<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <title>online-bookmarks installation</title>
  </head>
  <body>

<?php

$hostname = check_var ("mysql_hostname", "localhost");
$username = check_var ("mysql_db_username", "bookmarkmgr");
$password = check_var ("mysql_db_password", "");
$db_name = check_var ("mysql_db_name", "bookmarks");

if (intval(str_replace('.', '', phpversion())) < 410) {
	print_msg ('You are running PHP version '.PHP_VERSION.'. online-bookmarks requires at least PHP 4.1.0 to run properly. You must upgrade your PHP installation before you can continue.', "error");
}

############## database control ##############

function create_table_bookmark () {
		$query = "CREATE TABLE bookmark (
			user char(20) NOT NULL default '',
			title char(70) NOT NULL default '',
			url char(200) NOT NULL default '',
			description mediumtext default NULL,
			private enum('0','1') default NULL,
			date timestamp(14) NOT NULL,
			childof int(11) NOT NULL default '0',
			id int(11) NOT NULL auto_increment,
			deleted enum('0','1') NOT NULL default '0',
			favicon varchar(200),
			PRIMARY KEY  (id),
			FULLTEXT KEY title (title,url,description)
		) TYPE=MyISAM";

	if (mysql_query ($query)) {
		return true;
	}
	else {
		return false;
	}
}

function create_table_folder () {
	$query = "CREATE TABLE folder (
			id int(11) NOT NULL auto_increment,
			childof int(11) NOT NULL default '0',
			name char(70) NOT NULL default '',
			user char(20) NOT NULL default '',
			deleted enum('0','1') NOT NULL default '0',
			UNIQUE KEY id (id)
		) TYPE=MyISAM;";

	if (mysql_query ($query)) {
		return true;
	}
	else {
		return false;
	}
}

function create_table_user () {
	$query = "CREATE TABLE user (
			username char(50) NOT NULL default '',
			password char(50) NOT NULL default '',
			language char(20) NOT NULL default '',
			root_folder_name char(50) NOT NULL default 'My Bookmarks',
			column_width_folder smallint(3) NOT NULL default '220',
			column_width_bookmark smallint(3) NOT NULL default '320',
			table_height smallint(3) NOT NULL default '220',
			confirm_delete enum('0','1') NOT NULL default '1',
			open_new_window enum('0','1') NOT NULL default '1',
			show_bookmark_description enum('0','1') NOT NULL default '0',
			show_bookmark_icon enum('0','1') NOT NULL default '1',
			show_column_date enum('0','1') NOT NULL default '0',
			show_column_edit enum('0','1') NOT NULL default '1',
			show_column_move enum('0','1') NOT NULL default '1',
			show_column_delete enum('0','1') NOT NULL default '1',
			fast_folder_minus enum('0','1') NOT NULL default '0',
			fast_folder_plus enum('0','1') NOT NULL default '1',
			fast_symbol enum('0','1') NOT NULL default '1',
			simple_tree_mode enum('0','1') NOT NULL default '0',
			UNIQUE KEY id (username)
		) TYPE=MyISAM;";

	if (mysql_query ($query)) {
		return true;
	}
	else {
		return false;
	}
}

############## html stuff ##############

function html_db ($hostname, $username, $password, $db_name) {

	?>
	
	<h3>Database connection:</h3>
	Before connecting to the database you need to manually crate a database and a system user. You can do this
	by feeding something like this to your MySQL server:
	<pre>
	mysql> CREATE DATABASE bookmarks;
	mysql> GRANT ALL PRIVILEGES ON bookmarks.* TO 'bookmarkmgr'@'localhost' IDENTIFIED BY 'some_password';
	</pre>
	<form method="POST" action="">
	<table>

		<tr>
			<td>Hostname:</td>
			<td><input type="text" name="mysql_hostname" value="<?php echo $hostname; ?>"></td>
		</tr>

		<tr>
			<td>Username:</td>
			<td><input type="text" name="mysql_db_username" value="<?php echo $username; ?>"></td>
		</tr>

		<tr>
			<td>Password:</td>
			<td><input type="password" name="mysql_db_password" value="<?php echo $password; ?>"></td>
		</tr>

		<tr>
			<td>Database-Name:</td>
			<td><input type="text" name="mysql_db_name" value="<?php echo $db_name; ?>"></td>
		</tr>

		<tr>
			<td></td>
			<td><input type="submit" name="db"></td>
		</tr>
	</table>

	</form>
	
	<?php
}

function check_var ($varname, $default = "") {
	if (!isset ($_POST[$varname]) || $_POST[$varname] == "") {
		$var = $default;
	}
	else {
		$var = $_POST[$varname];
	}
	return trim ($var);
}

function print_msg ($message, $type = "") {
	if ($type == "success") {
		$color = "green";
	}
	else if ($type == "error") {
		$color = "red";
	}
	else if ($type == "notice") {
		$color = "orange";
	}
	else {
		$color = "black";
	}
	echo '<div style="font:bold 12pt Times; color: ' . $color . '">' . $message . '</div>' . "\n";
}

if (isset ($_POST['db'])) {
	$dsn = array(
		'username' => $username,
		'password' => $password,
		'hostspec' => $hostname,
		'database' => $db_name,
	);

	if (! @mysql_connect ($dsn['hostspec'], $dsn['username'], $dsn['password'])) {
		html_db ($hostname, $username, $password, $db_name);
		print_msg (mysql_error (), "error");
	}
	else {
		if (! @mysql_select_db ($dsn['database'])) {
			html_db ($hostname, $username, $password, $db_name);
			print_msg (mysql_error (), "error");
		}
		else {
			############## DB support ##############
			print_msg ("DB connection succeeded", "success");

			$query = "show tables";
			$tables = array ();
			$result = mysql_query ("$query");

			while ($row = mysql_fetch_row ($result)) {
				array_push ($tables, $row[0]);
			}

			# the bookmark table
			if (!in_array ("bookmark", $tables)) {
				if (create_table_bookmark ()) {
					print_msg ("Table bookmark created", "success");
				}
				else {
					print_msg (mysql_error (), "error");
				}
			}
			else {
				print_msg ("Table bookmark exists, checking for version:", "notice");
				
				$query = "desc bookmark";
				$result = mysql_query ("$query");
				$version = false;
				while ($row = mysql_fetch_row ($result)) {
					if ($row[0] == "favicon") {
						$version = true;
					}
				}

				if ($version) {
					print_msg ("Version of table bookmark OK, no need to upgrade", "success");
				}
				# It means that the table must be adjusted if the field favicon was not found.
				else {
					print_msg ("Favicon support not found in table, attempting to upgrade");
					$query = "ALTER TABLE bookmark ADD COLUMN favicon varchar(200)";
					if (mysql_query ($query)) {
						print_msg ("Table bookmark altered, favicon added.", "success");
					}
					else {
						print_msg ("Failure! Talbe not changed.", "error");
					}
				}
			}
			# the folder and user tables
			if (create_table_folder ()) {
				print_msg ("Table folder created", "success");
			}
			else {
				print_msg (mysql_error (), "notice");
			}

			if (create_table_user ()) {
				print_msg ("Table user created", "success");
			}
			else {
				print_msg (mysql_error (), "notice");
			}

			############## favicon support ##############
		
			if ($convert = @exec ('which convert')) {
				print_msg ("ImageMagick convert found: $convert", "success");
			}
			else {
				$convert = "";
				print_msg ("ImageMagick convert not found. Make sure ImageMagick is installed and specify location of convert manually in ./config/config.php", "error");
			}
		
			if ($identify = @exec ('which identify')) {
				print_msg ("ImageMagick identify found: $identify", "success");
			}
			else {
				$identify = "";
				print_msg ("ImageMagick identify not found. Make sure ImageMagick is installed and specify location of identify manually in ./config/config.php", "error");
			}
		
			if (is_writable ("./favicons/")) {
				print_msg ("./favicons directory is writable by the webserver, good.", "success");
			}
			else {
				print_msg ("./favicons directory is not writable by the webserver. Adjust permissions.", "error");
			}


			$config = '
&lt;?php
if (basename ($_SERVER[\'SCRIPT_NAME\']) == basename (__FILE__)) {
	die ("no direct access allowed");
}

$dsn = array(
	\'username\' => \'' . $username . '\',
	\'password\' => \'' . $password . '\',
	\'hostspec\' => \'' . $hostname . '\',
	\'database\' => \'' . $db_name . '\',
);

$convert = \'' . $convert . '\';
$identify = \'' . $identify . '\';
$timeout = 5;
$folder_closed = \'&lt;img src="./images/folder.gif" border="0" alt="" align="middle"&gt;\';
$folder_opened = \'&lt;img src="./images/folder_open.gif" border="0" alt="" align="middle"&gt;\';
$bookmark_image = \'&lt;img src="./images/bookmark_image.gif" align="middle" border="0" alt=""&gt;\';
$plus = \'&lt;img src="./images/plus.gif" align="middle" border="0" alt=""&gt;&nbsp;\';
$minus = \'&lt;img src="./images/minus.gif" align="middle" border="0" alt=""&gt;&nbsp;\';
$neutral = \'&lt;img src="./images/spacer.gif" border="0" alt="" width="13" height="1"&gt;&nbsp;\';
$edit_image = \'&lt;img src="./images/edit.gif" align="middle" border="0" alt="" title="%s"&gt;\';
$move_image = \'&lt;img src="./images/move.gif" align="middle" border="0" alt="" title="%s"&gt;\';
$delete_image = \'&lt;img src="./images/delete.gif" align="middle" border="0" alt="" title="%s"&gt;\';
$delimiter = "/";
?&gt;';

			echo '<p>Paste the configuration shown below in the configuration file <span style="font-family:courier">./config/config.php</span></p>' . "\n";
			print_msg ("<p>IMPORTANT! Do not forget to remove this install.php script.</p>");
			echo '<pre style="background-color: #E0E0E0; border: 1px black solid; padding: 20px">';
			echo $config;
			echo "</pre>\n";
			echo "After completing the configuration, create useraccounts with the following MySQL command:\n";
			echo "<pre>mysql> INSERT INTO user (username, password) VALUES ('johndoe', MD5('johndoes_password'));</pre>\n";
			echo '<a href="./index.php">Go Bookmark...</a>';
		}
	}
}
else {
	html_db ($hostname, $username, $password, $db_name);
}

?>

</body>
</html>

